/**
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2004 satoshi akabane(akabane@logical-paradox.org)
 *
 */
package org.logical_paradox.gdrn.shell;

import java.awt.event.KeyEvent;

import org.logical_paradox.console.Document;
import org.logical_paradox.console.event.ConsoleEventObject;
import org.logical_paradox.console.event.KeyPressListener;
import org.logical_paradox.shell.Shell;
import org.logical_paradox.shell.exception.ParserException;
import org.logical_paradox.shell.exception.TerminationException;

/**
 * L[Xi[()
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class KeyPressListenerImpl implements KeyPressListener {
	private Document document;
	private Shell shell;

	/**
	 * RXgN^
	 * @param d hLg
	 * @param shell VF
	 */
	public KeyPressListenerImpl(Document d, Shell s) {
		document = d;
		shell = s;
		document.prompt();
		document.relocate();
	}
	/**
	 * L[͊m莞ɌĂ΂nh
	 * @param e CxgIuWFNg
	 */
	public void onKeyPressed(ConsoleEventObject e) {
		if(document.isJapaneseMode() == true) {
			return;
		}
		switch(e.getKeyCode()) {
			case KeyEvent.VK_UP:			// J[\
			case KeyEvent.VK_DOWN:			// J[\
			case KeyEvent.VK_SHIFT:		// SHIFT
			case KeyEvent.VK_CONTROL:		// CTRL
			case KeyEvent.VK_CAPS_LOCK:	// CAPSLOCK
				break;
			case KeyEvent.VK_FULL_WIDTH:
			case KeyEvent.VK_HALF_WIDTH:
			case KeyEvent.VK_INPUT_METHOD_ON_OFF:
				return;
			// J[\
			case KeyEvent.VK_LEFT:
				document.moveToLeft();
				break;
			// J[\E
			case KeyEvent.VK_RIGHT:
				document.moveToRight();
				break;
			// HOME
			case KeyEvent.VK_HOME:
				// xJ[\ԍŌֈړ
				document.moveToEnd();
				// sփJ[\ړ
				document.moveToLineBegin();
				break;
			// DEL
			case KeyEvent.VK_DELETE:
				document.delete();
				break;
			// END
			case KeyEvent.VK_END:
				document.moveToEnd();
				break;
			// BS
			case KeyEvent.VK_BACK_SPACE:
				document.backSpace();					// BS
				break;									
			// ENTER
			case KeyEvent.VK_ENTER:
				// ENTERL[̓R}hs𒊏oăp[U[ɂ
				document.CRLF();
				if(document.getCommitedLine().trim().equals("") == false) {
					try {
						shell.execute(document.getOutputStream(), document.getCommitedLine());
					} catch (org.logical_paradox.shell.exception.CommandExecutionException e1) {
						// R}h̎sɎsꍇ
						document.insert(e1.toString());
						document.CRLF();
					} catch (ParserException e1) {
						// w肳ꂽR}h̍\ɊԈႢꍇ
						document.insert(e1.toString());
						document.CRLF();
					} catch(TerminationException te) {
						// IVOiMꍇ,vOI
						System.exit(0);
					}
				}
				// vvg\
				document.prompt();
				e.getKeyEvent().consume();
				break;
			default:
				if(e.getKeyEvent().getID() == KeyEvent.KEY_TYPED && e.getKeyChar() == KeyEvent.VK_BACK_SPACE) {
					document.backSpace();					// BS
				} else if(Character.isISOControl(e.getKeyChar()) == false) {
					document.insert(e.getKeyChar());		// ͑}
				}
				break;
		}
		// L[͂swinĝقŃnhOȂ̂ŁCŏ
		e.getKeyEvent().consume();
	}
}
