/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: DomainConnectionTester.java,v 1.2 2005/09/17 17:35:12 rampil Exp $
 */
package org.logical_paradox.vsan.sample;

import java.util.ResourceBundle;

import org.logical_paradox.common.io.RandomAccessFileDelegator;
import org.logical_paradox.common.util.StringUtils;
import org.logical_paradox.vsan.vfi.DistributedRandomAccessFile;


/**
 * Tvf[^C^[
 * Kȃf[^hCt@CVXeɑ΂ď݂܂
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class DomainConnectionTester {
	public static final String DEFAULT_RESOURCE_PFX = "sampledatawriter";
	private final ResourceBundle resource;

	// constructor
	public DomainConnectionTester() {
		this(DEFAULT_RESOURCE_PFX);
	}
	public DomainConnectionTester(String pfx) {
		resource = getResource(pfx);
	}
	protected ResourceBundle getResource(String pfx) {
		return ResourceBundle.getBundle(pfx);
	}
	// eXgP[Xs
	public void test() throws Exception {
		final String testdata = StringUtils.randomText(14, true);
		RandomAccessFileDelegator file = new DistributedRandomAccessFile(resource.getString("domain"), "sample");

		file.seek(0);

		// ̃f[^ޔ
		log("̃f[^ޔĂ܂..");
		byte[] bb = new byte[testdata.length()];
		file.read(bb);

		// eXgf[^
		log("eXgf[^ł܂..");
		System.out.println("Jn=" + System.currentTimeMillis());
		for(int i = 0; i < 1000; i++) {
			file.seek(0);
			file.write(testdata.getBytes());
		}
		System.out.println("I=" + System.currentTimeMillis());

		// eXgf[^ǂݍ
		log("eXgf[^ǂݍł܂..");
		file.seek(0);
		byte[] td = new byte[testdata.length()];
		int rb = file.read(td);

		// 
		log("eXgf[^؂Ă܂..");
		System.out.println("f[^ : " + rb + " ... " + (rb == testdata.length()));
		System.out.println("f[^   : " + new String(td).trim() + " ... " + (testdata.equals(new String(td).trim())));

		// ̃f[^
		log("eXgf[^폜Ă܂..");
		file.seek(0);
		file.write(bb);

		file.close();

		log("eXgI");
	}
	private void log(String msg) {
		System.out.println(msg);
	}
	// main method
	public static final void main(String[] args) throws Exception {
		DomainConnectionTester dataWriter = new DomainConnectionTester();
		dataWriter.test();
	}
}
