/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: DomainConnectionProvider.java,v 1.2 2005/09/07 13:38:06 rampil Exp $
 */
package org.logical_paradox.vsan.dfs;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import org.logical_paradox.vsan.domain.*;
import org.logical_paradox.vsan.domain.exception.DomainAccessException;

/**
 * hCڑvoC_[
 * 󋵂ɂāAVhCڑԂꍇ邵Â̂̂܂ܕԂꍇ
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class DomainConnectionProvider {
	/** RtBO[V */
	private final DfsConfig config;
	/** ڑhC */
	private Domain domain;

	/** ڑv[ */
	private List connectionPool = new ArrayList();

	/**
	 * RXgN^D
	 * @param cfg DFS̃RtBO
	 * @param d ڑhC
	 */
	public DomainConnectionProvider(DfsConfig cfg, Domain d) {
		config = cfg;
		domain = d;
	}
	/**
	 * ڑhCݒ肷D
	 * @param d ڑhC
	 */
	public void setDomain(Domain d) {
		domain = d;
	}
	/**
	 * ڑhCԂD
	 * @return ڑhC
	 */
	public Domain getDomain() {
		return domain;
	}
	/**
	 * ݂̐ڑv[OԂD
	 * @return ڑv[O
	 */
	protected int size() {
		return connectionPool.size();
	}
	/**
	 * hCڑ擾
	 * hCڑ́AKȐ̃NCAgŋL<br>
	 * NCAgɑ΂āAɓڑCX^X蓖Ă邽߁A<br>
	 * ŉĂł߂lɂȂB<br>
	 * 蓖ĂɎsꍇADomainAccessExceptionԂ
	 * @param clientNodeId NCAgID(null̏ꍇA蓖)
	 * @return w肳ꂽNCAgɊ蓖ĂꂽhCڑ
	 * @throws DomainAccessException 蓖ĂɎs
	 */
	public DomainConnection getConnection(String clientNodeId) throws DomainAccessException {
		synchronized(connectionPool) {
			// RlNVK̐菭ȂꍇAⓚpŐVڑm
			// Ԃ
			if(connectionPool.size() < config.getDomainConnectionMax()) {
				DomainConnection con = newConnection(clientNodeId);
				connectionPool.add(con);
				return con;
			}
			for(Iterator it = connectionPool.iterator(); it.hasNext();) {
				DomainConnection dc = (DomainConnection)it.next();
				if(dc.contains(clientNodeId) == true) {
					return dc;
				}
			}

			// 蓖ĂȂ̂ŁAL̏ȂɃ\[g
			Collections.sort(connectionPool);

			// Vڑ蓖Ă邩Ap
			DomainConnection con = (DomainConnection)connectionPool.get(0);
			if(con.getSharedNum() >= config.getDomainSessionConnections()) {
				// ڑ
				throw new DomainAccessException();
			}

			// ڑL
			con.share(clientNodeId);

			return con;
		}
	}
	/**
	 * VhCڑmD
	 * @param clientNodeId NCAgm[hID
	 * @return ꂽhCڑ
	 */
	protected DomainConnection newConnection(String clientNodeId) throws DomainAccessException {
		return new DomainConnection(clientNodeId, domain);
	}
}
