/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: DbRecord.java,v 1.2 2005/09/07 13:38:06 rampil Exp $
 */
package org.logical_paradox.vsan.node.dbr;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

/**
 * f[^t@C1R[h\钊ۃR[hIuWFNg
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class DbRecord {
	/** R[hTCY */
	private int recordSize;
	/** R[hԍ */
	private long recordNo;
	/** ̃R[h̃f[^ */
	private byte[] data;
	/** ̃R[h̗Lf[^TCY */
	private int datasize;

	/**
	 * RXgN^
	 * @param recordNo_ R[hԍ
	 * @param recordSize_ R[hTCY
	 */
	public DbRecord(long recordNo_, int recordSize_) {
		recordNo = recordNo_;
		recordSize = recordSize_;
	}
	/**
	 * RXgN^
	 * CX^XɁCf[^𕜌
	 * @param recordNo_ R[hԍ
	 * @param recordSize_ R[hTCY
	 * @param data oCg
	 */
	public DbRecord(long recordNo_, int recordSize_, byte[] data, int ds) {
		this(recordNo_, recordSize_);
		setData(data, ds);
	}
	/**
	 * w肳ꂽoCg񂩂烌R[h𕜌
	 * @param data oCg
	 * @param ds Lf[^TCY
	 */
	public void setData(byte[] data_, int ds) {
		data = data_;
		datasize = ds;
	}
	/**
	 * ̃R[h̃f[^{̂Ԃ
	 * @return f[^{
	 */
	public byte[] getData() {
		return data;
	}
	/**
	 * R[hԍԂ
	 * @return R[hԍ
	 */
	public long getRecordNo() {
		return recordNo;
	}
	/**
	 * R[hTCYԂ
	 * @return R[hTCY
	 */
	public int getRecordSize() {
		return recordSize;
	}
	/**
	 * ̃R[hɊi[Ăf[^̃TCYԂ
	 * @return ۂɗLȃf[^̃TCY
	 */
	public int getDatasize() {
		return datasize;
	}
	/**
	 * ̃R[hoCgɕϊ
	 * @return ϊꂽoCg
	 */
	public byte[] toByteStream() {
		// oCgXg[̃TCYvZ
		// R[hTCY(4bytes) + R[hԍ(8bytes) + f[^TCY(4bytes) + ۂ̃f[^
		int streamSize = 4 + 8 + 4 + datasize;
		byte[] b = new byte[streamSize];
		ByteBuffer bb = ByteBuffer.allocate(b.length).order(ByteOrder.BIG_ENDIAN);

		// R[hTCY
		bb.putInt(recordSize);
		// R[hԍ
		bb.putLong(recordNo);
		// f[^TCY
		bb.putInt(datasize);
		// f[^
		bb.put(data, 0, datasize);

		bb.rewind();
		return bb.array();
	}
}
