/*
 * $Id: getenv.java,v 1.2 2005/09/07 13:38:06 rampil Exp $
 * Copyright (c) 2004 LOGICAL-PARADOX.ORG
 */
package org.logical_paradox.vsan.tools.console.command;

import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;

import org.logical_paradox.shell.Argument;
import org.logical_paradox.shell.Command;
import org.logical_paradox.shell.ResultCode;
import org.logical_paradox.shell.ShellEnv;
import org.logical_paradox.shell.exception.CommandExecutionException;
import org.logical_paradox.shell.exception.TerminationException;

/**
 * <pre>
 * getenv
 * 
 * ydlz
 * ϐo͂܂B
 * 
 * yz
 * getenv [ϐ]
 * </pre>
 * 
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class getenv implements Command {
	public static final String USAGE = "getenv [variable-name [variable-name..]]";
	/**
	 * XgAbvꂽϐo͂
	 * @param ostream o̓Xg[
	 * @param env ϐ
	 * @param varnames ϐ̃Xg
	 */
	protected void printEnvironmentVariable(OutputStream ostream, ShellEnv env, ArrayList varnames) {
		PrintWriter pw = new PrintWriter(ostream);

		for(Iterator it = varnames.iterator(); it.hasNext();) {
			String varname = (String)it.next();
			pw.println(varname + "=" + env.getProperty(varname));
		}
		pw.flush();
		pw.close();
	}
	public ResultCode execute(OutputStream arg0, ShellEnv arg1, Argument arg2) throws CommandExecutionException, TerminationException {
		if(arg2 == null || arg2.getArguments().length == 0) {
			// ݓo^ĂSĂ̊ϐo͂
			printEnvironmentVariable(arg0, arg1, arg1.varNames());
		} else {
			// w肳ꂽϐ̂ݏo͂
			ArrayList varnames = new ArrayList();
			varnames.addAll(Arrays.asList(arg2.getArguments()));
			printEnvironmentVariable(arg0, arg1, varnames);
		}
		return new ResultCode(ResultCode.STATUS_OK);
	}
	public String usage() {
		return USAGE;
	}
}
